rm(list=ls())

library(xlsx)
setwd("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/discriminant_analysis/tanagra sas spss")
alcohol.data <- read.xlsx(file="alcohol.xls",sheetIndex=1,header=T)
print(summary(alcohol.data))

#linear discriminant analysis
library(MASS)
alcohol.lda <- lda(TYPE ~ ., data = alcohol.data)
print(alcohol.lda)

#prediction on the training set
pred.lda <- predict(alcohol.lda,newdata=alcohol.data)
print(attributes(pred.lda))
#confusion matrix
mc.lda <- table(alcohol.data$TYPE,pred.lda$class)
print(mc.lda)

#error rate
print(1-sum(diag(mc.lda))/sum(mc.lda))

#variable selection
library(klaR)
alcohol.forward <- greedy.wilks(TYPE ~ ., data = alcohol.data, niveau = 0.01)
print(alcohol.forward)

#2nd model with variable selection
alcohol.lda.fwd <- lda(alcohol.forward$formula, data = alcohol.data)
print(alcohol.lda.fwd)

#2nd confusion matrix
mc.lda.fwd <- table(alcohol.data$TYPE,predict(alcohol.lda.fwd,newdata=alcohol.data)$class)
print(mc.lda.fwd)

#2nd error rate
print(1-sum(diag(mc.lda.fwd))/sum(mc.lda.fwd))


